/**
 *
 * @author Zhuplev Anton
 */
import java.io.*;
import java.util.*;



public class sol_zhuplev implements Runnable {


  private String input = "input.txt";
  private String output = "output.txt";
  private Scanner in = null;
  private PrintWriter out = null;
  private final long maxN = (long)1 << 30;


  public sol_zhuplev() {
    try {
      in = new Scanner(new File(input));
      out = new PrintWriter(new File(output));
    } catch (Exception exept) {
      exept.printStackTrace();
      System.exit(216);
    }
  }


  public static void main(String[] args) {
    Locale.setDefault(Locale.US);
    new Thread(new sol_zhuplev()).start();
  }


  public void run() {
    try {
      solve();
      throw new Error("Assertion failure!!!");
    } catch (Exception exept) {
      exept.printStackTrace();
      System.exit(216);
    } finally {
      in.close();
      out.close();
    }
  }


  private void myAssert(boolean expr, String message) {
    if (!expr) {
      //throw new Error("Assertion failure!!! " + message);
      System.err.println("Assertion failure!!! " + message);
      System.exit(216);
    }
  }


  long readAndCheck(String varName) {
    long result = in.nextLong();
    myAssert(1 <= result && result <= maxN, String.format("%s is out of range", varName));
    return result;
  }


  long immediateLeft(long value, int step) {
    return value & ~((long)1 << step);
  }

  long immediateRight(long value, int step) {
    return value | ((long)1 << step);
  }

  @SuppressWarnings("unchecked")
  private void solve() {
    long n = readAndCheck("n") - 1;
    long x = readAndCheck("x") - 1;
    long y = readAndCheck("y") - 1;

    myAssert(x <= n && y <= n && x < y, "x and y are wrong");
    
    int k = 0;
    do {
      long xl = immediateLeft(x, k);
      long xr = immediateRight(x, k);

      long yl = immediateLeft(y, k);
      long yr = immediateRight(y, k);
      yr = yr > n ? yl : yr;

      if (xl == yl && xr == yr) {
        out.format("%d %d\n", xl+1, xr+1);
      } else {
        out.format("%d %d  %d %d\n", xl+1, xr+1, yl+1, yr+1);
      }

      x = xl; y = yl;
      k++;
    } while (x != y);
  }
}
